#include <jni.h>

#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>


extern "C" {


// http://man7.org/linux/man-pages/man2/select.2.html
JNIEXPORT jint JNICALL
Java_anonvpn_anon_1next_android_service_networking_Tunneling_waitForPackets(JNIEnv *env,
																																						jobject obj,
																																						jint fd_id)
	{
		fd_set rfds;
		struct timeval tv;
		int retval = -1;

		// Clear current set
		FD_ZERO(&rfds);
		// Add our FD to the set
		FD_SET(fd_id, &rfds);
		//    FD_SET(0, &rfds); /* Watch stdin (fd 0) to see when it has input. */

		// Set timeout
		tv.tv_sec = 10;
		tv.tv_usec = 0;

		// blocking select
		while (true)
			{
				retval = select(1, &rfds, NULL, NULL, &tv);

				if (retval < 0)
					{ //Error
						return -1;
					}
				else if (retval == 1)
					{ //socket is ready
						return 1;
					}
			}
	}
JNIEXPORT jint JNICALL
Java_anonvpn_anon_1next_android_AndroidVpnService_setBlocking(JNIEnv *env, jobject obj, jint fd_id)
	{
		int flags = fcntl(fd_id, F_GETFL, 0);

		if (flags < 0)
			{
				return -1;
			}

		flags = flags & (~O_NONBLOCK);

		int ret= fcntl(fd_id, F_SETFL, flags);
		if(ret==-1)
			int err=errno;
		return ret;
	}
}