package anonvpn.anon_next.android;

import android.util.Log;
import logging.AbstractLog;
import logging.LogLevel;

public class AndroidLog extends AbstractLog {

	private static final String TAG = "ANONmobile";

	public void log(int a_logLevel, int a_logType, String msg) {
		if (!isLogged(a_logLevel, a_logType)) {
			return;
		}

		switch (a_logLevel) {
			case LogLevel.EMERG:
				Log.e(TAG, "[EMERG] " + msg);
				break;
			case LogLevel.ALERT:
				Log.e(TAG, "[ALERT] " + msg);
				break;
			case LogLevel.EXCEPTION:
				Log.e(TAG, "[EXCEPTION] " + msg);
				break;
			case LogLevel.ERR:
				Log.e(TAG, "[ERROR] " + msg);
				break;
			case LogLevel.WARNING:
				Log.w(TAG, msg);
				break;
			case LogLevel.NOTICE:
				Log.v(TAG, msg);
				break;
			case LogLevel.INFO:
				Log.i(TAG, msg);
				break;
			case LogLevel.DEBUG:
				Log.d(TAG, msg);
				break;
		}
	}

}
