package anonvpn.anon_next.android.ui;

import android.graphics.Bitmap;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import anonvpn.anon_next.android.R;

import java.text.DecimalFormat;

public class AppDetailActivity extends AppCompatActivity {

    TextView _title;
    TextView _traffic;
    TextView _perm;
    ImageView _icon;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setTitle(getString(R.string.appd_label_title));
        String[] permissions = getIntent().getStringArrayExtra("permissions");

        // Get a support ActionBar corresponding to this toolbar
        ActionBar ab = getSupportActionBar();
        // Enable the Up button
        if (ab != null) {
            ab.setDisplayHomeAsUpEnabled(true);
        }

        setContentView(R.layout.activity_app_detail);

        String title = getIntent().getStringExtra("title");
        Bitmap bitmap = getIntent().getParcelableExtra("Bitmap");
        long defaultVal = 0;
        long rxBytes = getIntent().getLongExtra("rxBytes", defaultVal);
        long txBytes = getIntent().getLongExtra("txBytes", defaultVal);


        View view = findViewById(R.id.activity_app_detail);
        _title = (TextView) view.findViewById(R.id.appd_tv_title);
        _perm = (TextView) view.findViewById(R.id.appd_tv_perm);
        _icon = (ImageView) view.findViewById(R.id.appd_iv_icon);
        _traffic = (TextView) view.findViewById(R.id.appd_tv_traffic);

        StringBuilder builder = new StringBuilder();
        for (String s : permissions) {
            String[] temp = s.split("\\.");
            builder.append(temp[temp.length - 1]).append("\n");
        }

        _title.setText(title);
        _perm.setText(builder.toString());
        DecimalFormat df = new DecimalFormat("#.00");

        if(txBytes==0){
            _traffic.setText("Up: " + ((int) rxBytes) + " kB\n" + "Down: " + ((int) txBytes) + " kB");
        }
        else {
            _traffic.setText("Up: " + df.format(rxBytes) + " kB\n" + "Down: " + df.format(txBytes) + " kB");
        }
        _icon.setImageBitmap(bitmap);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }

    }
}